diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/test/int64x64-test-suite.cc ns-3.46/src/core/test/int64x64-test-suite.cc
--- ns-3.45/src/core/test/int64x64-test-suite.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/test/int64x64-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
@@ -805,66 +805,66 @@
 
     // NOLINTBEGIN(misc-redundant-expression)
     // clang-format off
-  Check(                 1ULL, "+0.0000000000000000000542");
-  Check(                 2ULL, "+0.0000000000000000001084");
-  Check(                 3ULL, "+0.0000000000000000001626");
-  Check(                 4ULL, "+0.0000000000000000002168");
-  Check(                 5ULL, "+0.0000000000000000002710");
-  Check(                 6ULL, "+0.0000000000000000003253");
-  Check(                 7ULL, "+0.0000000000000000003795");
-  Check(                 8ULL, "+0.0000000000000000004337");
-  Check(                 9ULL, "+0.0000000000000000004879");
-  Check(               0xAULL, "+0.0000000000000000005421");
-  Check(               0xFULL, "+0.0000000000000000008132");
-  Check(              0xF0ULL, "+0.0000000000000000130104");
-  Check(             0xF00ULL, "+0.0000000000000002081668");
-  Check(            0xF000ULL, "+0.0000000000000033306691");
-  Check(           0xF0000ULL, "+0.0000000000000532907052");
-  Check(          0xF00000ULL, "+0.0000000000008526512829");
-  Check(         0xF000000ULL, "+0.0000000000136424205266");
-  Check(        0xF0000000ULL, "+0.0000000002182787284255");
-  Check(       0xF00000000ULL, "+0.0000000034924596548080");
-  Check(      0xF000000000ULL, "+0.0000000558793544769287");
-  Check(     0xF0000000000ULL, "+0.0000008940696716308594");
-  Check(    0xF00000000000ULL, "+0.0000143051147460937500");
-  Check(   0xF000000000000ULL, "+0.0002288818359375000000");
-  Check(  0xF0000000000000ULL, "+0.0036621093750000000000");
-  Check( 0xF00000000000000ULL, "+0.0585937500000000000000");
-  std::cout << std::endl;
-  Check(0x7FFFFFFFFFFFFFFDULL, "+0.4999999999999999998374", tolerance);
-  Check(0x7FFFFFFFFFFFFFFEULL, "+0.4999999999999999998916", tolerance);
-  Check(0x7FFFFFFFFFFFFFFFULL, "+0.4999999999999999999458", tolerance);
-  Check(0x8000000000000000ULL, "+0.5000000000000000000000");
-  Check(0x8000000000000001ULL, "+0.5000000000000000000542", tolerance);
-  Check(0x8000000000000002ULL, "+0.5000000000000000001084", tolerance);
-  Check(0x8000000000000003ULL, "+0.5000000000000000001626", tolerance);
-  std::cout << std::endl;
-  Check(0xF000000000000000ULL, "+0.9375000000000000000000");
-  Check(0xFF00000000000000ULL, "+0.9960937500000000000000");
-  Check(0xFFF0000000000000ULL, "+0.9997558593750000000000");
-  Check(0xFFFF000000000000ULL, "+0.9999847412109375000000");
-  Check(0xFFFFF00000000000ULL, "+0.9999990463256835937500");
-  Check(0xFFFFFF0000000000ULL, "+0.9999999403953552246094");
-  Check(0xFFFFFFF000000000ULL, "+0.9999999962747097015381");
-  Check(0xFFFFFFFF00000000ULL, "+0.9999999997671693563461");
-  Check(0xFFFFFFFFF0000000ULL, "+0.9999999999854480847716");
-  Check(0xFFFFFFFFFF000000ULL, "+0.9999999999990905052982");
-  Check(0xFFFFFFFFFFF00000ULL, "+0.9999999999999431565811");
-  Check(0xFFFFFFFFFFFF0000ULL, "+0.9999999999999964472863");
-  Check(0xFFFFFFFFFFFFF000ULL, "+0.9999999999999997779554");
-  Check(0xFFFFFFFFFFFFFF00ULL, "+0.9999999999999999861222");
-  Check(0xFFFFFFFFFFFFFFF0ULL, "+0.9999999999999999991326");
-  Check(0xFFFFFFFFFFFFFFF5ULL, "+0.9999999999999999994037", tolerance);
-  Check(0xFFFFFFFFFFFFFFF6ULL, "+0.9999999999999999994579", tolerance);
-  Check(0xFFFFFFFFFFFFFFF7ULL, "+0.9999999999999999995121", tolerance);
-  Check(0xFFFFFFFFFFFFFFF8ULL, "+0.9999999999999999995663", tolerance);
-  Check(0xFFFFFFFFFFFFFFF9ULL, "+0.9999999999999999996205", tolerance);
-  Check(0xFFFFFFFFFFFFFFFAULL, "+0.9999999999999999996747", tolerance);
-  Check(0xFFFFFFFFFFFFFFFBULL, "+0.9999999999999999997289", tolerance);
-  Check(0xFFFFFFFFFFFFFFFCULL, "+0.9999999999999999997832", tolerance);
-  Check(0xFFFFFFFFFFFFFFFDULL, "+0.9999999999999999998374", tolerance);
-  Check(0xFFFFFFFFFFFFFFFEULL, "+0.9999999999999999998916", tolerance);
-  Check(0xFFFFFFFFFFFFFFFFULL, "+0.9999999999999999999458", tolerance);
+    Check(                 1ULL, "+0.0000000000000000000542");
+    Check(                 2ULL, "+0.0000000000000000001084");
+    Check(                 3ULL, "+0.0000000000000000001626");
+    Check(                 4ULL, "+0.0000000000000000002168");
+    Check(                 5ULL, "+0.0000000000000000002710");
+    Check(                 6ULL, "+0.0000000000000000003253");
+    Check(                 7ULL, "+0.0000000000000000003795");
+    Check(                 8ULL, "+0.0000000000000000004337");
+    Check(                 9ULL, "+0.0000000000000000004879");
+    Check(               0xAULL, "+0.0000000000000000005421");
+    Check(               0xFULL, "+0.0000000000000000008132");
+    Check(              0xF0ULL, "+0.0000000000000000130104");
+    Check(             0xF00ULL, "+0.0000000000000002081668");
+    Check(            0xF000ULL, "+0.0000000000000033306691");
+    Check(           0xF0000ULL, "+0.0000000000000532907052");
+    Check(          0xF00000ULL, "+0.0000000000008526512829");
+    Check(         0xF000000ULL, "+0.0000000000136424205266");
+    Check(        0xF0000000ULL, "+0.0000000002182787284255");
+    Check(       0xF00000000ULL, "+0.0000000034924596548080");
+    Check(      0xF000000000ULL, "+0.0000000558793544769287");
+    Check(     0xF0000000000ULL, "+0.0000008940696716308594");
+    Check(    0xF00000000000ULL, "+0.0000143051147460937500");
+    Check(   0xF000000000000ULL, "+0.0002288818359375000000");
+    Check(  0xF0000000000000ULL, "+0.0036621093750000000000");
+    Check( 0xF00000000000000ULL, "+0.0585937500000000000000");
+    std::cout << std::endl;
+    Check(0x7FFFFFFFFFFFFFFDULL, "+0.4999999999999999998374", tolerance);
+    Check(0x7FFFFFFFFFFFFFFEULL, "+0.4999999999999999998916", tolerance);
+    Check(0x7FFFFFFFFFFFFFFFULL, "+0.4999999999999999999458", tolerance);
+    Check(0x8000000000000000ULL, "+0.5000000000000000000000");
+    Check(0x8000000000000001ULL, "+0.5000000000000000000542", tolerance);
+    Check(0x8000000000000002ULL, "+0.5000000000000000001084", tolerance);
+    Check(0x8000000000000003ULL, "+0.5000000000000000001626", tolerance);
+    std::cout << std::endl;
+    Check(0xF000000000000000ULL, "+0.9375000000000000000000");
+    Check(0xFF00000000000000ULL, "+0.9960937500000000000000");
+    Check(0xFFF0000000000000ULL, "+0.9997558593750000000000");
+    Check(0xFFFF000000000000ULL, "+0.9999847412109375000000");
+    Check(0xFFFFF00000000000ULL, "+0.9999990463256835937500");
+    Check(0xFFFFFF0000000000ULL, "+0.9999999403953552246094");
+    Check(0xFFFFFFF000000000ULL, "+0.9999999962747097015381");
+    Check(0xFFFFFFFF00000000ULL, "+0.9999999997671693563461");
+    Check(0xFFFFFFFFF0000000ULL, "+0.9999999999854480847716");
+    Check(0xFFFFFFFFFF000000ULL, "+0.9999999999990905052982");
+    Check(0xFFFFFFFFFFF00000ULL, "+0.9999999999999431565811");
+    Check(0xFFFFFFFFFFFF0000ULL, "+0.9999999999999964472863");
+    Check(0xFFFFFFFFFFFFF000ULL, "+0.9999999999999997779554");
+    Check(0xFFFFFFFFFFFFFF00ULL, "+0.9999999999999999861222");
+    Check(0xFFFFFFFFFFFFFFF0ULL, "+0.9999999999999999991326");
+    Check(0xFFFFFFFFFFFFFFF5ULL, "+0.9999999999999999994037", tolerance);
+    Check(0xFFFFFFFFFFFFFFF6ULL, "+0.9999999999999999994579", tolerance);
+    Check(0xFFFFFFFFFFFFFFF7ULL, "+0.9999999999999999995121", tolerance);
+    Check(0xFFFFFFFFFFFFFFF8ULL, "+0.9999999999999999995663", tolerance);
+    Check(0xFFFFFFFFFFFFFFF9ULL, "+0.9999999999999999996205", tolerance);
+    Check(0xFFFFFFFFFFFFFFFAULL, "+0.9999999999999999996747", tolerance);
+    Check(0xFFFFFFFFFFFFFFFBULL, "+0.9999999999999999997289", tolerance);
+    Check(0xFFFFFFFFFFFFFFFCULL, "+0.9999999999999999997832", tolerance);
+    Check(0xFFFFFFFFFFFFFFFDULL, "+0.9999999999999999998374", tolerance);
+    Check(0xFFFFFFFFFFFFFFFEULL, "+0.9999999999999999998916", tolerance);
+    Check(0xFFFFFFFFFFFFFFFFULL, "+0.9999999999999999999458", tolerance);
     // clang-format on
     // NOLINTEND(misc-redundant-expression)
 }
@@ -1152,6 +1152,7 @@
      *
      * This will lie in the closed interval [0, 64]
      */
+    // NOLINTNEXTLINE(misc-redundant-expression)
     static constexpr int MISS_MANT_DIG = std::max(0, 64 - LDBL_MANT_DIG);
 
     /**
@@ -1540,8 +1541,8 @@
     std::cout << std::endl;
 
 #if defined(INT64X64_USE_CAIRO) && !defined(PYTHON_SCAN)
-    std::cout << "cairo_impl64:  " << cairo_impl64 << std::endl;
-    std::cout << "cairo_impl128: " << cairo_impl128 << std::endl;
+    std::cout << "cairo_impl64:  " << cairo_impl64() << std::endl;
+    std::cout << "cairo_impl128: " << cairo_impl128() << std::endl;
 #endif
 
     if (RUNNING_WITH_LIMITED_PRECISION != 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/test/simulator-test-suite.cc ns-3.46/src/core/test/simulator-test-suite.cc
--- ns-3.45/src/core/test/simulator-test-suite.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/test/simulator-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
@@ -235,45 +235,39 @@
      *
      * @{
      */
-
-    // clang-format off
-
-    void bar0() {}
-    void bar1(int) {}
-    void bar2(int, int) {}
-    void bar3(int, int, int) {}
-    void bar4(int, int, int, int) {}
-    void bar5(int, int, int, int, int) {}
-    void baz1(int&) {}
-    void baz2(int&, int&) {}
-    void baz3(int&, int&, int&) {}
-    void baz4(int&, int&, int&, int&) {}
-    void baz5(int&, int&, int&, int&, int&) {}
-    void cbaz1(const int&) {}
-    void cbaz2(const int&, const int&) {}
-    void cbaz3(const int&, const int&, const int&) {}
-    void cbaz4(const int&, const int&, const int&, const int&) {}
-    void cbaz5(const int&, const int&, const int&, const int&, const int&) {}
-
-    void bar0c() const {}
-    void bar1c(int) const {}
-    void bar2c(int, int) const {}
-    void bar3c(int, int, int) const {}
-    void bar4c(int, int, int, int) const {}
-    void bar5c(int, int, int, int, int) const {}
-    void baz1c(int&) const {}
-    void baz2c(int&, int&) const {}
-    void baz3c(int&, int&, int&) const {}
-    void baz4c(int&, int&, int&, int&) const {}
-    void baz5c(int&, int&, int&, int&, int&) const {}
-    void cbaz1c(const int&) const {}
-    void cbaz2c(const int&, const int&) const {}
-    void cbaz3c(const int&, const int&, const int&) const {}
-    void cbaz4c(const int&, const int&, const int&, const int&) const {}
-    void cbaz5c(const int&, const int&, const int&, const int&, const int&) const {}
-
-    // clang-format on
-
+    void bar0() {};
+    void bar1(int) {};
+    void bar2(int, int) {};
+    void bar3(int, int, int) {};
+    void bar4(int, int, int, int) {};
+    void bar5(int, int, int, int, int) {};
+    void baz1(int&) {};
+    void baz2(int&, int&) {};
+    void baz3(int&, int&, int&) {};
+    void baz4(int&, int&, int&, int&) {};
+    void baz5(int&, int&, int&, int&, int&) {};
+    void cbaz1(const int&) {};
+    void cbaz2(const int&, const int&) {};
+    void cbaz3(const int&, const int&, const int&) {};
+    void cbaz4(const int&, const int&, const int&, const int&) {};
+    void cbaz5(const int&, const int&, const int&, const int&, const int&) {};
+
+    void bar0c() const {};
+    void bar1c(int) const {};
+    void bar2c(int, int) const {};
+    void bar3c(int, int, int) const {};
+    void bar4c(int, int, int, int) const {};
+    void bar5c(int, int, int, int, int) const {};
+    void baz1c(int&) const {};
+    void baz2c(int&, int&) const {};
+    void baz3c(int&, int&, int&) const {};
+    void baz4c(int&, int&, int&, int&) const {};
+    void baz5c(int&, int&, int&, int&, int&) const {};
+    void cbaz1c(const int&) const {};
+    void cbaz2c(const int&, const int&) const {};
+    void cbaz3c(const int&, const int&, const int&) const {};
+    void cbaz4c(const int&, const int&, const int&, const int&) const {};
+    void cbaz5c(const int&, const int&, const int&, const int&, const int&) const {};
     /** @} */
 };
 
@@ -282,27 +276,22 @@
  *
  * @{
  */
-
-// clang-format off
-
-static void foo0() {}
-static void foo1(int) {}
-static void foo2(int, int) {}
-static void foo3(int, int, int) {}
-static void foo4(int, int, int, int) {}
-static void foo5(int, int, int, int, int) {}
-static void ber1(int&) {}
-static void ber2(int&, int&) {}
-static void ber3(int&, int&, int&) {}
-static void ber4(int&, int&, int&, int&) {}
-static void ber5(int&, int&, int&, int&, int&) {}
-static void cber1(const int&) {}
-static void cber2(const int&, const int&) {}
-static void cber3(const int&, const int&, const int&) {}
-static void cber4(const int&, const int&, const int&, const int&) {}
-static void cber5(const int&, const int&, const int&, const int&, const int&) {}
-
-// clang-format on
+static void foo0() {};
+static void foo1(int) {};
+static void foo2(int, int) {};
+static void foo3(int, int, int) {};
+static void foo4(int, int, int, int) {};
+static void foo5(int, int, int, int, int) {};
+static void ber1(int&) {};
+static void ber2(int&, int&) {};
+static void ber3(int&, int&, int&) {};
+static void ber4(int&, int&, int&, int&) {};
+static void ber5(int&, int&, int&, int&, int&) {};
+static void cber1(const int&) {};
+static void cber2(const int&, const int&) {};
+static void cber3(const int&, const int&, const int&) {};
+static void cber4(const int&, const int&, const int&, const int&) {};
+static void cber5(const int&, const int&, const int&, const int&, const int&) {};
 
 /** @} */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/test/timer-test-suite.cc ns-3.46/src/core/test/timer-test-suite.cc
--- ns-3.45/src/core/test/timer-test-suite.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/test/timer-test-suite.cc	2025-10-01 18:46:32.000000000 -0700
@@ -23,26 +23,20 @@
 
 namespace
 {
-
-// clang-format off
-
 /// Function with one int parameter.
-void bari(int) {}
+void bari(int) {};
 /// Function with two int parameters.
-void bar2i(int, int) {}
+void bar2i(int, int) {};
 /// Function with three int parameters.
-void bar3i(int, int, int) {}
+void bar3i(int, int, int) {};
 /// Function with four int parameters.
-void bar4i(int, int, int, int) {}
+void bar4i(int, int, int, int) {};
 /// Function with five int parameters.
-void bar5i(int, int, int, int, int) {}
+void bar5i(int, int, int, int, int) {};
 /// Function with one const int reference parameter.
-void barcir(const int&) {}
+void barcir(const int&) {};
 /// Function with one int reference parameter.
-void barir(int&) {}
-
-// clang-format on
-
+void barir(int&) {};
 } // anonymous namespace
 
 using namespace ns3;
@@ -110,30 +104,26 @@
     void DoRun() override;
     void DoTeardown() override;
 
-    // clang-format off
-
     /// Member function with one int parameter.
-    void bazi(int) {}
+    void bazi(int) {};
     /// Member function with two int parameters.
-    void baz2i(int, int) {}
+    void baz2i(int, int) {};
     /// Member function with three int parameters.
-    void baz3i(int, int, int) {}
+    void baz3i(int, int, int) {};
     /// Member function with four int parameters.
-    void baz4i(int, int, int, int) {}
+    void baz4i(int, int, int, int) {};
     /// Member function with five int parameters.
-    void baz5i(int, int, int, int, int) {}
+    void baz5i(int, int, int, int, int) {};
     /// Member function with six int parameters.
-    void baz6i(int, int, int, int, int, int) {}
+    void baz6i(int, int, int, int, int, int) {};
     /// Member function with one const int reference parameter.
-    void bazcir(const int&) {}
+    void bazcir(const int&) {};
     /// Member function with one int reference parameter.
-    void bazir(int&) {}
+    void bazir(int&) {};
     /// Member function with one int pointer parameter.
-    void bazip(int*) {}
+    void bazip(int*) {};
     /// Member function with one const int pointer parameter.
-    void bazcip(const int*) {}
-
-    // clang-format on
+    void bazcip(const int*) {};
 };
 
 TimerTemplateTestCase::TimerTemplateTestCase()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/csma/model/backoff.h ns-3.46/src/csma/model/backoff.h
--- ns-3.45/src/csma/model/backoff.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/csma/model/backoff.h	2025-10-01 18:46:32.000000000 -0700
@@ -105,7 +105,7 @@
 
   private:
     /**
-     * Number of times that the transmitter has tried to unsuccessfuly transmit the current packet.
+     * Number of times that the transmitter has tried to unsuccessfully transmit the current packet.
      */
     uint32_t m_numBackoffRetries;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/energy/CMakeLists.txt ns-3.46/src/energy/CMakeLists.txt
--- ns-3.45/src/energy/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/energy/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -17,7 +17,6 @@
     model/energy-harvester.cc
     model/energy-source.cc
     model/generic-battery-model.cc
-    model/li-ion-energy-source.cc
     model/rv-battery-model.cc
     model/simple-device-energy-model.cc
   HEADER_FILES
@@ -37,10 +36,9 @@
     model/energy-harvester.h
     model/energy-source.h
     model/generic-battery-model.h
-    model/li-ion-energy-source.h
     model/rv-battery-model.h
     model/simple-device-energy-model.h
   LIBRARIES_TO_LINK ${libnetwork}
   TEST_SOURCES test/basic-energy-harvester-test.cc
-               test/li-ion-energy-source-test.cc
+               test/generic-battery-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/energy/examples/CMakeLists.txt ns-3.46/src/energy/examples/CMakeLists.txt
--- ns-3.45/src/energy/examples/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/energy/examples/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -18,13 +18,6 @@
 )
 
 build_lib_example(
-  NAME li-ion-energy-source-example
-  SOURCE_FILES li-ion-energy-source-example.cc
-  LIBRARIES_TO_LINK ${libcore}
-                    ${libenergy}
-)
-
-build_lib_example(
   NAME rv-battery-model-test
   SOURCE_FILES rv-battery-model-test.cc
   LIBRARIES_TO_LINK
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/energy/test/basic-energy-harvester-test.cc ns-3.46/src/energy/test/basic-energy-harvester-test.cc
--- ns-3.45/src/energy/test/basic-energy-harvester-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/energy/test/basic-energy-harvester-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -77,8 +77,6 @@
     harvester->SetNode(node);
     harvester->SetEnergySource(source);
 
-    Time now = Simulator::Now();
-
     /*
      * The energy harvester will recharge the energy source for m_timeS seconds.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/energy/test/examples-to-run.py ns-3.46/src/energy/test/examples-to-run.py
--- ns-3.45/src/energy/test/examples-to-run.py	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/energy/test/examples-to-run.py	2025-10-01 18:46:32.000000000 -0700
@@ -7,7 +7,6 @@
 #
 # See test.py for more information.
 cpp_examples = [
-    ("li-ion-energy-source", "True", "True"),
     ("rv-battery-model-test", "True", "True"),
     ("basic-energy-model-test", "True", "True"),
 ]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/energy/test/generic-battery-test.cc ns-3.46/src/energy/test/generic-battery-test.cc
--- ns-3.45/src/energy/test/generic-battery-test.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/energy/test/generic-battery-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,91 @@
+/*
+ * Copyright (c) 2024 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ * Based on the works of Andrea Sacco (2010)
+ */
+
+#include "ns3/core-module.h"
+#include "ns3/energy-module.h"
+
+using namespace ns3;
+using namespace ns3::energy;
+
+/**
+ * @ingroup energy-tests
+ *
+ * @brief Discharge a battery test
+ */
+class DischargeBatteryTestCase : public TestCase
+{
+  public:
+    DischargeBatteryTestCase();
+
+    void DoRun() override;
+
+    Ptr<Node> m_node; //!< Node to aggregate the source to.
+};
+
+DischargeBatteryTestCase::DischargeBatteryTestCase()
+    : TestCase("Discharge a Li-Ion Panasonic CGR18650DA battery")
+{
+}
+
+void
+DischargeBatteryTestCase::DoRun()
+{
+    // This test demonstrates that the battery reach its cutoff voltage in a little less than 1
+    // hour. When discharged with a constant current of 2.33 A (Equivalent to 1C).
+    // Note: The cutoff voltage is only reached within this time for the specified battery
+    // (PANASONIC CGR18650DA Li-Ion).
+
+    Ptr<Node> node = CreateObject<Node>();
+    GenericBatteryModelHelper batteryHelper;
+    Ptr<GenericBatteryModel> batteryModel =
+        DynamicCast<GenericBatteryModel>(batteryHelper.Install(node, PANASONIC_CGR18650DA_LION));
+
+    Ptr<SimpleDeviceEnergyModel> consumptionEnergyModel = CreateObject<SimpleDeviceEnergyModel>();
+    consumptionEnergyModel->SetEnergySource(batteryModel);
+    batteryModel->AppendDeviceEnergyModel(consumptionEnergyModel);
+    consumptionEnergyModel->SetNode(node);
+
+    // Needed to initialize battery model
+    batteryModel->UpdateEnergySource();
+
+    // Discharge the battery with a constant current of 2.33 A (1C)
+    consumptionEnergyModel->SetCurrentA(2.33);
+
+    Simulator::Stop(Seconds(3459));
+    Simulator::Run();
+
+    NS_TEST_ASSERT_MSG_EQ_TOL(batteryModel->GetSupplyVoltage(),
+                              3.0,
+                              1.0e-2,
+                              "Cutoff voltage not reached");
+    node->Dispose();
+    consumptionEnergyModel->Dispose();
+    batteryModel->Dispose();
+    Simulator::Destroy();
+}
+
+/**
+ * @ingroup energy-tests
+ *
+ * @brief Generic battery TestSuite
+ */
+class GenericBatteryTestSuite : public TestSuite
+{
+  public:
+    GenericBatteryTestSuite();
+};
+
+GenericBatteryTestSuite::GenericBatteryTestSuite()
+    : TestSuite("generic-battery-test", Type::UNIT)
+{
+    AddTestCase(new DischargeBatteryTestCase, TestCase::Duration::QUICK);
+}
+
+/// create an instance of the test suite
+static GenericBatteryTestSuite g_genericBatteryTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/fd-net-device/CMakeLists.txt ns-3.46/src/fd-net-device/CMakeLists.txt
--- ns-3.45/src/fd-net-device/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/fd-net-device/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -1,26 +1,26 @@
 set(module_enabled_features) # modulegen_customizations consumes this list
 
-check_include_file(
+check_include_file_cxx(
   net/ethernet.h
   HAVE_NET_ETHERNET_H
 )
-check_include_file(
+check_include_file_cxx(
   netpacket/packet.h
   HAVE_PACKET_H
 )
-check_include_file(
+check_include_file_cxx(
   net/if.h
   HAVE_IF_NETS_H
 )
-check_include_file(
+check_include_file_cxx(
   linux/if_tun.h
   HAVE_IF_TUN_H
 )
-check_include_file(
+check_include_file_cxx(
   net/netmap_user.h
   HAVE_NETMAP_USER_H
 )
-check_include_file(
+check_include_file_cxx(
   sys/ioctl.h
   HAVE_SYS_IOCTL_H
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/fd-net-device/helper/creator-utils.cc ns-3.46/src/fd-net-device/helper/creator-utils.cc
--- ns-3.45/src/fd-net-device/helper/creator-utils.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/fd-net-device/helper/creator-utils.cc	2025-10-01 18:46:32.000000000 -0700
@@ -9,6 +9,7 @@
 #include "encode-decode.h"
 
 #include <arpa/inet.h>
+#include <cstdlib>
 #include <cstring>
 #include <errno.h>
 #include <iomanip>
@@ -17,7 +18,6 @@
 #include <net/if.h>
 #include <netinet/in.h>
 #include <sstream>
-#include <stdlib.h>
 #include <string>
 #include <sys/ioctl.h>
 #include <sys/socket.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/fd-net-device/helper/emu-fd-net-device-helper.cc ns-3.46/src/fd-net-device/helper/emu-fd-net-device-helper.cc
--- ns-3.45/src/fd-net-device/helper/emu-fd-net-device-helper.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/fd-net-device/helper/emu-fd-net-device-helper.cc	2025-10-01 18:46:32.000000000 -0700
@@ -19,6 +19,7 @@
 #include "ns3/trace-helper.h"
 
 #include <arpa/inet.h>
+#include <cstdlib>
 #include <errno.h>
 #include <iomanip>
 #include <iostream>
@@ -28,7 +29,6 @@
 #include <net/if.h>
 #include <netinet/in.h>
 #include <netpacket/packet.h>
-#include <stdlib.h>
 #include <string.h>
 #include <string>
 #include <sys/ioctl.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/fd-net-device/helper/encode-decode.cc ns-3.46/src/fd-net-device/helper/encode-decode.cc
--- ns-3.45/src/fd-net-device/helper/encode-decode.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/fd-net-device/helper/encode-decode.cc	2025-10-01 18:46:32.000000000 -0700
@@ -4,10 +4,10 @@
  * SPDX-License-Identifier: GPL-2.0-only
  */
 
+#include <cstdint>
 #include <iomanip>
 #include <iostream>
 #include <sstream>
-#include <stdint.h>
 #include <string>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/fd-net-device/helper/raw-sock-creator.cc ns-3.46/src/fd-net-device/helper/raw-sock-creator.cc
--- ns-3.45/src/fd-net-device/helper/raw-sock-creator.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/fd-net-device/helper/raw-sock-creator.cc	2025-10-01 18:46:32.000000000 -0700
@@ -7,6 +7,7 @@
 #include "creator-utils.h"
 
 #include <arpa/inet.h>
+#include <cstdlib>
 #include <errno.h>
 #include <iomanip>
 #include <iostream>
@@ -15,7 +16,6 @@
 #include <netinet/in.h>
 #include <netpacket/packet.h>
 #include <sstream>
-#include <stdlib.h>
 #include <string>
 #include <sys/ioctl.h>
 #include <sys/socket.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/fd-net-device/helper/tap-device-creator.cc ns-3.46/src/fd-net-device/helper/tap-device-creator.cc
--- ns-3.45/src/fd-net-device/helper/tap-device-creator.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/fd-net-device/helper/tap-device-creator.cc	2025-10-01 18:46:32.000000000 -0700
@@ -9,6 +9,8 @@
 #include "ns3/mac48-address.h"
 
 #include <arpa/inet.h>
+#include <cstdint>
+#include <cstdlib>
 #include <cstring>
 #include <errno.h>
 #include <fcntl.h>
@@ -19,8 +21,6 @@
 #include <net/route.h>
 #include <netinet/in.h>
 #include <sstream>
-#include <stdint.h>
-#include <stdlib.h>
 #include <sys/ioctl.h>
 #include <sys/socket.h>
 #include <sys/types.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/fd-net-device/helper/tap-fd-net-device-helper.cc ns-3.46/src/fd-net-device/helper/tap-fd-net-device-helper.cc
--- ns-3.45/src/fd-net-device/helper/tap-fd-net-device-helper.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/fd-net-device/helper/tap-fd-net-device-helper.cc	2025-10-01 18:46:32.000000000 -0700
@@ -19,6 +19,7 @@
 #include "ns3/trace-helper.h"
 
 #include <arpa/inet.h>
+#include <cstdlib>
 #include <errno.h>
 #include <iomanip>
 #include <iostream>
@@ -28,7 +29,6 @@
 #include <net/if.h>
 #include <netinet/in.h>
 #include <netpacket/packet.h>
-#include <stdlib.h>
 #include <string.h>
 #include <string>
 #include <sys/ioctl.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/flow-monitor/helper/flow-monitor-helper.cc ns-3.46/src/flow-monitor/helper/flow-monitor-helper.cc
--- ns-3.45/src/flow-monitor/helper/flow-monitor-helper.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/flow-monitor/helper/flow-monitor-helper.cc	2025-10-01 18:46:32.000000000 -0700
@@ -85,15 +85,16 @@
     Ptr<Ipv4L3Protocol> ipv4 = node->GetObject<Ipv4L3Protocol>();
     if (ipv4)
     {
-        Ptr<Ipv4FlowProbe> probe =
-            Create<Ipv4FlowProbe>(monitor, DynamicCast<Ipv4FlowClassifier>(classifier), node);
+        auto probe =
+            CreateObject<Ipv4FlowProbe>(monitor, DynamicCast<Ipv4FlowClassifier>(classifier), node);
     }
     Ptr<FlowClassifier> classifier6 = GetClassifier6();
     Ptr<Ipv6L3Protocol> ipv6 = node->GetObject<Ipv6L3Protocol>();
     if (ipv6)
     {
-        Ptr<Ipv6FlowProbe> probe6 =
-            Create<Ipv6FlowProbe>(monitor, DynamicCast<Ipv6FlowClassifier>(classifier6), node);
+        auto probe6 = CreateObject<Ipv6FlowProbe>(monitor,
+                                                  DynamicCast<Ipv6FlowClassifier>(classifier6),
+                                                  node);
     }
     return m_flowMonitor;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/helper/internet-trace-helper.cc ns-3.46/src/internet/helper/internet-trace-helper.cc
--- ns-3.45/src/internet/helper/internet-trace-helper.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/helper/internet-trace-helper.cc	2025-10-01 18:46:32.000000000 -0700
@@ -15,8 +15,8 @@
 #include "ns3/pcap-file-wrapper.h"
 #include "ns3/ptr.h"
 
+#include <cstdint>
 #include <fstream>
-#include <stdint.h>
 #include <string>
 
 namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/global-route-manager.cc ns-3.46/src/internet/model/global-route-manager.cc
--- ns-3.45/src/internet/model/global-route-manager.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/global-route-manager.cc	2025-10-01 18:46:32.000000000 -0700
@@ -25,6 +25,8 @@
 //
 // ---------------------------------------------------------------------------
 
+uint32_t GlobalRouteManager::routerId = 0;
+
 void
 GlobalRouteManager::DeleteGlobalRoutes()
 {
@@ -50,8 +52,13 @@
 GlobalRouteManager::AllocateRouterId()
 {
     NS_LOG_FUNCTION_NOARGS();
-    static uint32_t routerId = 0;
     return routerId++;
 }
 
+void
+GlobalRouteManager::ResetRouterId()
+{
+    routerId = 0;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/internet/model/global-route-manager.h ns-3.46/src/internet/model/global-route-manager.h
--- ns-3.45/src/internet/model/global-route-manager.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/internet/model/global-route-manager.h	2025-10-01 18:46:32.000000000 -0700
@@ -59,6 +59,16 @@
      * per-node forwarding tables
      */
     static void InitializeRoutes();
+
+    /**
+     * @brief Reset the router ID counter to zero. This should only be called by tests to reset the
+     * router ID counter between simulations within the same program. This function should not be
+     * called In typical simulations or when using the GlobalRouting helper.
+     */
+    static void ResetRouterId();
+
+  private:
+    static uint32_t routerId; //!< Router ID counter
 };
 
 } // namespace ns3
